# Denso::Calendar

[![Gem Version](https://badge.fury.io/rb/denso-calendar.svg)](https://badge.fury.io/rb/denso-calendar)
![CI/CD](https://github.com/satoryu/denso-calendar/workflows/CI/CD/badge.svg)

This gem provides a CLI and API for developers to parse DENSO Calendar published in [the website](https://www.denso.com/jp/ja/about-us/calendar/).

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'denso-calendar'
```

And then execute:

```sh
bundle install
```

Or install it yourself as:

```sh
gem install denso-calendar
```

## Usage

### CLI

This gem provides a CLI `denso-calendar`.
You can see all holidays for a specific employee type as follows:

```sh
desnso-calendar --type production
```

#### Options

- `-t TYPE`, `--type TYPE`: Optional. `production` in default. `production`, `tokyo` and `flex` are available.
- `-f FORMATTER`, `--formatter FORMATTER`: Optional. `plain` in default. `ical` and `plain` are available.

#### Generated ics files

You can get samples of ics files generated by the latest version of the cli:

- https://satoryu.github.io/denso-calendar/production.ics
- https://satoryu.github.io/denso-calendar/flex.ics
- https://satoryu.github.io/denso-calendar/tokyo.ics

You can import the above to your calendar/scheduling software like Outlook :calendar:

### API

You can deal with holidays in Denso Calendar in your code:

```ruby
require 'denso/calendar'

calendar = Denso::Calendar.load # :production in default.

holidays = calendar.holidays # returns an Array of Date
```

[Read more...](https://satoryu.github.io/denso-calendar/)

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/satoryu/denso-calendar. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/satoryu/denso-calendar/blob/master/CODE_OF_CONDUCT.md).


## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the Denso::Calendar project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/satoryu/denso-calendar/blob/master/CODE_OF_CONDUCT.md).
